package org.relaxer.bus.rConfig;

/**
 * @version application.rxm 1.0 (Wed Jan 02 23:42:47 JST 2002)
 * @author  Relaxer 0.15.1b (http://www.relaxer.org)
 */
public interface IRVisitor {
    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(CApplication visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(CApplication visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(CUsage visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(CUsage visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(CHelp visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(CHelp visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(CComponent visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(CComponent visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(CProperty visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(CProperty visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(CPipe visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(CPipe visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(CBus visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(CBus visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(CSlot visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(CSlot visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(CParticle visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(CParticle visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(RString visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(RString visitable);
}
